
CONST
  MAXSEENBY        = 500;
  MAXPATH          = 50;

TYPE
  BooleanSet       = Array[1..256] of Boolean;

  SortType         = (SNONE, SFILE, SAREA, SGROUP);

  ListType         = (LIST, QUERY, UNLINKED);

  InfoStatusBits   = (Local, FileSent, FileProcessed, NoDupe, FB5, FB6, FB7, FB8);

  FrequencyType    = (Imm, Dayly, Weekly, Weekly2, Monthly, Monthly2, Monthly3);

  ArchiverType     = (ZIP,ARJ,LZH,ARC,PAK,a6,a7,a8,a9,a10,ALL);

  ScheduleType     = (SC_Hatch, SC_Report, SC_Exec, SC_Post, Sc5, Sc6);

  FileStatusType   = (OK, BADCRC, BADPATH, ILLEGAL, UNKNOWN, DUPLICATE, NOTFOUND,
                      BADDESCR, NOACTION, NOACCESS, VIRUSFOUND);

  ExceptionType    = (Ex_Move, Ex_Adopt, Ex_NoForward, Ex_PassThru,
                    Ex_CopyFile, Ex_Otherpath, Ex_CopyArea, Ex_Magic,
                    Ex_Delete, Ex_Unpack, Ex_Exec, Ex12, Ex13, Ex14, Ex15, Ex16);

  PackerBits       = (Convert, SameArchive, AvArchive, Extension, ca1, ca2, ca3, ca4);
  PackerType       = Set of PackerBits;

  StatusBits       = (Announce, Backup, Crc, Tiny, Secure, DupCheck, ImportDiz,
                      Hide, HatchNew, AnnNew, Disc, Noti, B13, Virus, LongDesc, B16);
  StatusType       = Set of StatusBits;

  SystemStatusBits = (ForwReq, CanCreate, Remote, Upmagic, From, DoNotify, Pause, AddNew, Netmail, C2, C3, C4, C5, C6, C7, C8);
  SystemStatusType = Set of SystemStatusBits;

  MailStatusBits   = (Crash, Hold, Direct, PackTIC, PackFile, ms5, ms6, ms7, ms8, ms9, ms10);
  MailStatusType   = Set of MailStatusBits;

  MsgAttribType    = (Privat, CrashMail, Rcvd, Sent, FAttach, Transit, Orphan, KillSent, Loc, HoldMail, DirectMail,
                      FileRequest, ReturnReceiptRequest, IsReturnReceipt, AuditRequest, FileUpdateReq);
  MsgAttribSet     = Set of MsgAttribType;

  MsgStatusBits    = (TearLine, M2,M3,M4,M5,M6, Net,Echo);
  MsgStatusType    = Set of MsgStatusBits;

  NodeBits         = (Export,Import,Mandatory,PreRelease,n5,n6,n7,n8);
  NodeBitsType     = Set of NodeBits;

  LogBits          = (LFatal,LOther,LAccounting,z1,LForwarding,LBrief,LTrivial,z2,
                      LSession, LProcess);
  LogStatusBits    = Set of LogBits;

  NodeType = Record
    Zone,
    Net,
    Node,
    Point          : Word;
  End;

  ExportType = Record
    A              : NodeType;
    S              : NodeBitsType;
    M              : MailStatusType;
  End;

  ZoneAkaRecord = Record
    Zone,
    Net            : Word;
    AKA            : Byte;
  End;

  FlowType = Array[1..12] of Record
    Bytes,
    Files          : Longint;
  End;

  UplinkRecord = Record
    Address        : Nodetype;
    Mgrname,
    Password       : String[15];
    Groups         : BooleanSet;
    Status         : Byte;                                  { $02 = + prefix }
    Areafile       : String[80];
    Aka            : Byte;
  End;

  SetupType = Record
    Version        : Word;                         { SETUP.FM -> Version nr. }

    Address        : Array[1..21] of NodeType;
    Alias          : Array[1..15] of String[20];
    ZoneToAKA      : Array[1..20] of ZoneAkaRecord;
    Uplink         : array[1..20] of UplinkRecord;

    SysopName,
    SystemName     : String[40];
    RegKey         : String[12];

    Password,
{}  SeriNum,
{}  CustNum        : String[22];

    InboundPath    : String[80];
    OutboundPath   : String[80];
    NetmailPath    : String[80];
    BadFilePath    : String[80];
    AreaPath       : String[80];
    QuoteFile      : String[80];
    TPLpath        : String[80];
    LogFile        : String[80];
    AliasFile      : Array[1..2] of String[80];                { Alias files }
    Quepath        : String[80];                          { dbridge que path }
    TempPath       : String[80];          { path voor uitpakken/virusscannen }
    Semaphorepath  : String[80];                       { path for semaphores }
    RetirePath     : String[80];           { path for 'to be replaced' files }
    AreaLog        : String[80];             { path voor areamanager logfile }
    LogStatus      : LogStatusBits;        { de verschillende logfile opties }

    KillRcvd     : Boolean;                    { misc -> kill rcvd requests }
    Touch        : Boolean;                           { misc -> touch files }
    Replace      : Boolean;     { misc -> replace older files with new ones }
    ForceIntl    : Boolean;                      { misc force ^aintl kludge }
    IgnUnknown   : Boolean;                  { misc -> ignore unknown areas }
    UpdAlias     : Boolean;              { misc -> update mailer alias file }
    ExtendedDiz  : Boolean;    { ignore extended ascii in file_id.diz files }
    SortArea     : Boolean;                 { misc -> sort by area or group }
    IgnBadCRC    : Boolean;                  { misc -> ignore bad crc files }
    UseAreaDesc  : Boolean;    { misc -> use AREADESC keyword for new areas }
    Days2Keep    : Byte;             { misc -> days to keep files for nodes }
    DescStart    : Byte;      { which column desc starts -> files.bbs files }
    HistoryWeeks : Byte;                    { misc -> weeks to keep history }
    HistoryKb    : Byte;                         { misc -> max history size }
    TimeZone     : ShortInt;                       { misc -> utc difference }
    DefaultPwd   : String[15];                   { misc -> default password }
{}  Currency     : String[3];         { misc -> costsharing currency symbol }
    UpdateOld    : Boolean;  { update old *.?IC packets, or only create new }
    DupChecking  : Byte;           { 0 = area only, 1 = group only, 2 = all }

{}  Garbled,
{}  Encrypted,
{}  Report,
{}  Rtrcpt,                          { not used yet }
{}  Source,
{}  Topo         : Boolean;

    Packername   : Array[1..11] of string[12];
    packswitch   : Array[1..11] of string[44];
    bannerswitch : array[1..11] of string[43];
    unpackername : array[1..10] of string[12];
    unpackswitch : array[1..10] of string[43];

    unused2 : array[1..9] of char;

    ShowPack     : Boolean;                      { external -> show packing }
    ShowUnPack   : Boolean;                    { external -> show unpacking }
    Showswapping : Boolean;                  { show number of bytes swapped }
    ShowVirus    : Boolean;                  { external -> show virus check }
    VirusPath    : String[80];                { path + name to virusscanner }
    VirusParm    : String[50];               { parameters voor virusscanner }
    VirusErr     : Byte;           { hoogste errorlevel that means no virus }
    Virusfiles   : Byte;                { 0 = alleen exe,com,ovl, 1 = alles }
    SwapMethode  : Integer;                { ems / xms / disk swap volgorde }

    Mailer       : Byte; { 1 = fd, 2 = blinky, 3 = dbridge, 4 = Pop, 5 = Im }
    Filebase     : Byte;                   { 0 = files.bbs / 1 = ra 2.0 fdb }
    SemaMode     : Byte;   { 0 = none, 1 = binkley, 2 = fd, 3 = im, 4 = PoP }
    SecsToWait   : Word;  
    MaxWaitTime  : Word;  

    FFstar,                                   { filefind -> expand * to ?'s }
    FFone        : Byte;              { filefind -> max number of ? allowed }
    FFkeylen     : Byte;            { filefind -> minimum length of keyword }
    FFmax        : Byte;                  { filefind -> max number of files }
    FFloc        : Boolean;             { filefind -> respond to local msgs }
    FFmaxsize    : Byte;                         { filefind -> max msg size }

    OrigLine     : Array[1..15] of String[60];

    NameCount    : Longint;                { internal var }
    MaxMsgSize   : Byte;                   { max netmail msg size }

    Readkey,                               { hotkeys for filefind door }
    Scankey,
    Yellkey,
    Helpkey,
    Enterkey,
    Quitkey,
    Logoffkey  : Char;
    Yelltime   : Byte;
    FFLogfile  : String[80];
    Mainfile   : String[12];
    Helpfile   : String[12];
    Logofffile : String[12];

    DayArray   : Array[1..7] of string[15];
    MonthArray : Array[1..12] of string[15];

    BannerArray : Array[1..15] of string[60];
    SecurePath  : String[80];

    UnUsed     : Array[1..9] of byte;
  End;

  GroupType  = Record
    GroupName    : String[40];            { GROUPS.FM -> Name of this group }
    GroupNr      : Byte;

    Format       : String[12];               { files.bbs -> tpl file to use }
    Directory    : String[80];                   { group directory to files }
    ListSpec     : String[80];                        { files.bbs file name }
    Rearchive    : PackerType;                          { rearchive options }
    UseArchiver  : ArchiverType;             { rearchive -> archiver to use }
    BatchFile    : String[12];         { batchfile to execute on every file }
    Aka          : Byte;                         { aka to use on forwarding }
    Status       : StatusType;                  { status bits of this group }
    ReplaceMode  : Byte;  { 0 = no replace, 1 = hard replace, 2 = move file }
    Msgid        : BooleanSet;                      { announcements to make }
    MsgFile      : String[80];              { msgtxt to attach to this file }
    KeepDays     : Word;                        { delete files after x days }
    KeepAmount   : Word;                          { keep maximum of x files }
    Flow         : Flowtype;                     { file flow for this group }
    LastMonth    : Byte;                                { last active month }
    CostPerBlock : Word;                                   { costs per unit }
    Block        : Byte;                { 0 = 100 kb, 1 = 1024 kb, 2 = file }
    AllLinks     : Boolean;      { count all links or only active cso links }
    AddPercent   : Byte;               { percentage to add to cost per unit }

    DefaultDesc  : String[60];       

    InclHost     : Boolean;                       { count host as link also }
    InclUplink   : Boolean;                 { use uplink costs in tic files }
    Usebanner    : Byte;
    NotUsed      : Array[1..7] of Byte;
  End;

  AreaIndexType  = Record
    Tag          : String[20];     { AREAFILE.FMX -> name used in tic files }
    AreaRec      : LongInt;                         { Offset to AREAFILE.FM }
    Grp          : Byte;                       { Group this area belongs to }
  End;

  AreaType  = Record
    Tag          : String[20];      { AREAFILE.FM -> name used in tic files }
    ExportNr     : Word;                        { number of connected links }
    Grp          : Byte;                       { group this area belongs in }
    Name         : String[50];           { name or description of this area }
    AreaNr       : Word; { 0 = use files.bbs, >0 = recnummer to areafile.fm }

    Format       : String[12];               { files.bbs -> tpl file to use }
    Directory    : String[80];                         { directory to files }
    ListSpec     : String[80];            { files.bbs file directory + name }
    Rearchive    : PackerType;                          { rearchive options }
    UseArchiver  : ArchiverType;             { rearchive -> archiver to use }
    BatchFile    : String[12];         { batchfile to execute on every file }
    Aka          : Byte;                         { aka to use on forwarding }
    Status       : StatusType;                   { status bits of this area }
    ReplaceMode  : Byte;  { 0 = no replace, 1 = hard replace, 2 = move file }
    Msgid        : BooleanSet;                      { announcements to make }
    MsgFile      : String[80];              { msgtxt to attach to this file }
    KeepDays     : Word;                        { delete files after x days }
    KeepAmount   : Word;                          { keep maximum of x files }
    Flow         : Flowtype;                      { file flow for this area }
    LastMonth    : Byte;                                { last active month }
    CostPerBlock : Word;                                   { costs per unit }
    Block        : Byte;                { 0 = 100 kb, 1 = 1024 kb, 2 = file }
    AllLinks     : Boolean;      { count all links or only active cso links }
    AddPercent   : Byte;               { percentage to add to cost per unit }

    InclHost     : Boolean;                       { count host as link also }
    InclUplink   : Boolean;                 { use uplink costs in tic files }
    Usebanner    : Byte;
    NotUsed      : Array[1..7] of Byte;
  End;

  NodeIndexType = Record
    Address      : NodeType;       {NODEFILE.FMX -> node adress of this node }
    NodeRec      : LongInt;                { offset to record in NODEFILE.FM }
  End;

  NodeFileType = Record
    Address      : NodeType;        { NODEFILE.FM -> node adress of this node }
    AkaAddress   : NodeType;                        { aka adress of this node }
    SysopName    : String[50];                                  { sysops name }
    Password     : String[15];                       { password in tick files }
    MgrPassword  : String[15];                         { password for manager }
    Groups       : BooleanSet;                                { groups active }
    Visible      : BooleanSet;                       { groups visible in list }
    NewGroup     : Byte;                                  { default new group }
    Tictype      : Byte;                { 0 = none; 1 = antique; 2 = advanced }
    DefStatus    : MailStatusType;         { no packing, pack tic, pack files }
    Archiver     : ArchiverType;                { archiver to use for packing }
    MaxSize      : Word;                             { maximum size of bundle }
    MgrStatus    : MailStatusType;       { default status (crash,hold,direct) }

    Billing      : Boolean;          { billing manager active for this node ? }
    BillGroups   : BooleanSet;            { billing is active in these groups }
    Credit       : Real;                 { the actual account credit in cents }
    WarnLevel    : LongInt;                       { min account to warn sysop }
     Empty : array[1..2] of char;
    SendBill     : Byte;      { 0 = direct, 1 = daily, 2 = weekly, 3 = montly }
    SendDay      : Byte;                             { daynumber for sendbill }
    AddPercent   : Byte;              { percentage to add to total bill block }

    Status       : SystemStatusType;
    Flow         : Flowtype;
    Lastmonth    : Byte;

    WarnNot      : Boolean;                   { notified of low credit level }
    StopLevel    : Longint;   { minimum account level to switch node passive }

    Unused       : Array[1..5] of Byte;
  End;

  MessageType = Record
    MessageNr    : Byte;                    { MESSAGES.FM -> Message group ID }
    MessageName  : String[50];                          { Message description }

    Sortorder    : SortType;                   { how to sort the file entries }
    HeaderTpl,                                           { the tpl file names }
    FooterTpl,
    EntryTpl,
    BlockHdrTpl,                     { only used with sortorder AREA or GROUP }
    BlockFtrTpl  : String[12];                { idem, only with AREA or GROUP }

    MsgBaseId    : Char;           { the msgbase id: hudson, squize, fido etc }
    MsgBaseIdStr : String[80];               { board number + path of msgbase }
    Status       : MsgStatusType;                   { tearline + echo/netmail }
    MaxSize      : Byte;                                { maximum msgtxt size }

    MsgTo,                                                  { message to name }
    MsgFrom      : String[35];                            { message from name }
    MsgRe        : String[50];                              { message subject }
    MsgAttr      : MsgAttribSet;               { attrib bits: crash, hold etc }
    Origin,                                  { origin to use, or 0 for random }
    Aka          : Byte;                              { aka (fromnode) to use }
    ToNode       : NodeType;                     { to node address if netmail }

    Freq         : FrequencyType;                                 { frequency }
    Next         : LongInt;                                      { next event }
    Day          : Byte;                        { sunday = 1, monday = 2, etc }

    NotUsed      : Array[1..10] of Byte;
  End;

 ScheduleRec = Record
   Kind         : ScheduleType;                { hatch, report, exec or post }

   MsgBaseId    : Char;           { the msgbase id: hudson, squize, fido etc }
   MsgBaseIdStr : String[80];               { board number + path of msgbase }
   Status       : MsgStatusType;                   { tearline + echo/netmail }
   MaxSize      : Byte;                                { maximum msgtxt size }

   MsgTo,                                                  { message to name }
   MsgFrom      : String[35];                            { message from name }
   MsgAttr      : MsgAttribSet;               { attrib bits: crash, hold etc }
   Aka          : Byte;                              { aka (fromnode) to use }
   ToNode       : NodeType;                     { to node address if netmail }

   Freq         : FrequencyType;                                 { frequency }
   Next         : LongInt;                                      { next event }
   Day          : Byte;                        { sunday = 1, monday = 2, etc }

   Grps         : BooleanSet;
   Mask         : String[60];
   Tag          : String[20];
   Magic        : String[20];
   Line         : Array[1..3] of String[76];

   Inactive     : Boolean;
   NotUsed      : Array[1..9] of Byte;
 End;

 ScanAreaType = Record                                         { FILEFIND.FM }
   MsgBaseId      : Char;         { the msgbase id: hudson, squize, fido etc }
   MsgBaseIdStr   : String[80];             { board number + path of msgbase }
   Status         : MsgStatusType;                 { tearline + echo/netmail }

   ReplyBaseId    : Char;         { the msgbase id: hudson, squize, fido etc }
   ReplyBaseIdStr : String[80];             { board number + path of msgbase }
   ReplyStatus    : MsgStatusType;                            { echo/netmail }
   MsgAttr        : MsgAttribSet;             { attrib bits: crash, hold etc }

   HeaderTpl,                                                { the tpl files }
   FooterTpl,
   EntryTpl,
   BlockHdrTpl,
   BlockFtrTpl    : String[12];

   Origin,                                  { origin to use, or 0 for random }
   Aka            : Byte;                            { aka (fromnode) to use }
    NotUsed       : Array[1..10] of byte;
 End;

 BbsAreaType = Record        { FILEAREA.FM   -> first record is different! }
   On           : Boolean;                   { true -> active for filefind }
   Name         : String[40];                              { filearea name }
   Nr           : Word;                         { ra2.0 -> filebase number }
   Path         : String[50];                    { path to files directory }
 End;

 ExceptionRec = Record
   Kind         : ExceptionType;
   Mask         : String[12];

   FromArea     : String[20];
   ToArea       : String[20];
   FromNode     : Nodetype;
   Line         : Array[1..2] of String[80];

   NotUsed      : Array[1..10] of Byte;
 End;

TYPE
  Nfxtlist   = Array[1..1000] of NodeIndexType;                { nodes index }
  Afxtlist   = Array[1..2000] of AreaIndexType;                { areas index }
  SystemList = Array[1..256]  of ExportType;                { area downlinks }

